#
# Copyright 1995 Sun Microsystems, Inc.
# All rights reserved.
#
#ident	"@(#)ius.sh	1.13	95/09/25 SMI"
#
#UI-cmd#

trap 'exit 0' 1 2 3 15

authorized || exit 0

########
# clean (No Arg)
#
#	function to perform house cleaning at the end of the procedure
#	or when bail out for some other reasons such as failure.
#
clean()
{
	cleanup
	freevar SYSV3
}


########
# Main()
#

SYSV3=${SYSV3:-""}
export SYSV3
setvar -ui SYSV3 "$SYSV3"
device=$1

UI batch << EOF
	file ${CMDdotUI}
	window select main
	window select ius
EOF

mount -r -F s5fs ${device} /install >$ERROR_FILE 2>&1
if [ $? -ne 0 ] ; then
	UI call errmsg ${ERROR_FILE}
else
	# IUS packages have dependencies on many other packages, most of
	# which are not not installable or are redundant, so we override
	# the dependencies mechanism by creating any /usr/options/* files
	# that the package is about to look for, then deleting them after
	# installation.

	for dir in /install/* ; do
		d=`basename $dir`
		if [ -r $dir/install/dependencies ] ; then
			dfiles=`fgrep /usr/options/ $dir/install/dependencies | \
				tr ' ' '\012' | \
				fgrep /usr/options/ | \
				fgrep -v /usr/options/$d.name`


			for f in $dfiles ; do
				[ ! -f $f ] && echo DUMMY_DEPENDENCY_FILE > $f
			done
		fi
	done

	UI wexec ${CURRWD}/runINSTALL.sh ${device} /install

	rm `fgrep -l DUMMY_DEPENDENCY_FILE /usr/options/*` 2>/dev/null
fi
UI infomsg %contkey
UI waitkey
UI cls ius
umount /install  >/dev/null 2>&1

clean
exit 0
