#!/bin/sh
#
# Copyright 1995 Sun Microsystems, Inc.
# All rights reserved.
#
#ident	"@(#)runINSTALL.sh	1.6	95/10/02 SMI"
#

trap 'exit 0' 1 2 3 15

#############################################################################
# Initialize functions:
#

# Interactive INSTALL scripts on the diskette mistakenly calls  "ui cls"
# when it is in non-UIaware mode (no UIserver running).  This function
# does nothing in the case of the INSTALL script.  However, it may
# handle preinstall and postinstall scripts on the diskette for pacakages
# which call "ui" commands, not realizing there is no UI server.  This
# will translate "ui print" commands to "echo's" and we may have to support
# other ui commands at a later date.

ui()
{
	if [ "$1" = "print" ] 
	then
		echo "${2}"	
	fi
}

# The mount command is not binary compatible yet.  Use this mount function 
# to transform the INTERACTIVE mount command format into the Solaris format.
mount() {
	ARGS= ; Fflag=0 ; OPTIND=1
	while getopts amrpvVf:F:o:O  i
	do
		case $i in
		f|F) 
			Fflag=1 
			case "$OPTARG" in
				S51K) ARGS="$ARGS -F s5fs" ;;
				HS)   ARGS="$ARGS -F hsfs" ;;
				DOS)  ARGS="$ARGS -F pcfs" ;;
				*)    # Unsupported filesystem type, pass it
				      # thru anyway in case mount got clever.
				      ARGS="$ARGS -F $OPTARG" ;;
			esac
			;;

		o) ARGS="$ARGS -o $OPTARG" ;;		

		*) ARGS="$ARGS -$i" ;;
		esac
	done
	shift `expr $OPTIND - 1`

	# This is for backward compatibility.  "-r" may be at the end; move it.
	[ "$3" = "-r"  ] && ARGS="-r $ARGS" && set -- "$1" "$2"

	# Must give an fstyp otherwise "ufs" is used by default. 
	[ $# -ge 2 -a $Fflag -eq 0 ] && ARGS="$ARGS -F s5fs"

	/etc/mount $ARGS $*
}

tput()
{
	:
	# When running an ordinary shell script in a window via "UI wexec"
	# you may not do "tput clear" to the screen.  It shows up as escape
	# sequences. 
}

device=$1
TMPINSTALL=${UITMPPATH}/INSTALL.${CMD}$$
cp /install/install/INSTALL $TMPINSTALL
# The INSTALL file on the diskette uses "/etc/mount" cmd w/out specifying
# FS type.  Modify INSTALL script to run mount function above.
ed -s $TMPINSTALL <<- EOF > /dev/null
			g?/etc/mount?s?/etc/mount?mount?
			w
			q
EOF
chmod +x $TMPINSTALL 
$TMPINSTALL ${device} /install
rm $TMPINSTALL
