#
#
# Copyright 1995 Sun Microsystems, Inc.
# All rights reserved.
#
#ident	"@(#)pkgview.sh	1.14	95/09/24 SMI"
#UI-cmd#

trap 'exit 0' 1 2 3 15

########
# clean (No Arg)
#
#	function to perform house cleaning at the end of the procedure
#	or when bail out for some other reasons such as failure.
#
clean()
{
	cleanup
}


########
# init_form: 
#
#	Initialize form contents.
#
init_form ()
{
	pkgtype="$1"	
	case "$pkgtype" in
	
			############### SVR3 #####################
	preSVR4)
		if [ -s "$OptFile" ] ; then

			PKGINST=${pkg}
			NAME=`cat $OptFile`
			VERSION=`expr "$NAME" : '.*\(Version.*\)' | awk '{print $2}'`
			INSTDATE=`ls -l $OptFile | cut -c42-53`
			CATEGORY="SVR3.2"
			ARCH="x86"

		fi
		;;

			############### CUSTOM #####################
	custom)
		opts=""
		[ -n "$pkg_dir" ] && opts="-p $pkg_dir"
		eval `customlist -s $opts ${pkg}`
		;;

			############### SVR4 on the media ##################
	preinstSVR4)
			eval `sed -e "s/=/=\"/" -e "s/$/\"/" < $pkg_dir/$pkg/pkginfo`
			PKGINST="$PKG"
			# Separate VERSION and REV numbers.
			REV=`echo $VERSION | cut -d"," -f2`
			VERSION=`echo $VERSION | cut -d"," -f1`
			[ "$VERSION" = "$REV" ] && REV=""
			SIZE=`$LIST_PKG -s $pkg_dir $pkg`  		# Size in bytes
			SIZE=`echo "scale=1;$SIZE/1048576" | bc`	# Size in MB
			INSTDATE=`UI message lookup %NotInstalled`
		;;

			############### SVR4 #####################
	*)	
		# Transform most of pkginfo output into variable format
	        # (e.g. NAME="the name") so it can be "eval'd" later.
		# We delete any '"' chars as they will interfere. Bug id # 1205395
		pkginfo -R $pkg_dir -l ${pkg} | tr -d '"' | sed 's/[ 	]*\([^:]*\):[ 	]*\(.*\)/\1="\2\"/g' > $InfoFile
		if [ -s "$InfoFile" ] ; then
			# Bring variables into current scope.  Can't dot file 
			# because it contains other needed info (like size) that
			# is not in variable=value format.
			eval `fgrep = $InfoFile`
			BLOCKS_512=`fgrep "blocks used" $InfoFile | awk '{print $1}'`
			SIZE=`echo "scale=1;$BLOCKS_512/2048" | bc`	# Size in MB

			# Separate VERSION and REV numbers.
			REV=`echo $VERSION | cut -d"," -f2`
			VERSION=`echo $VERSION | cut -d"," -f1`
			[ "$VERSION" = "$REV" ] && REV=""
		fi
		;;
	esac
}

########
# Main()
#

#############################################################################
# Initialize variables
#############################################################################
pkg="${1}"
pkg_type="${2}"
pkg_dir="$3"				# Currently only passed in by preinstSVR4
InfoFile=${UITMPPATH}/pkginfo_optl	
OptFile=/usr/options/${pkg}.name
LIST_PKG=lspkg

setvar -ui vpkg "$pkg"
UI infomsg %getview_m
freevar vpkg
UI clrinfo
PKGINST=
NAME=
VERSION=
REV=
INSTDATE=
SIZE=
CATEGORY=
ARCH=
VENDOR=

# Initialize form variables
init_form $pkg_type
UI batch <<EOF
	file ${CMDdotUI}
	infomsg %buttons_only_i
	call viewpkg "$PKGINST" "$NAME" "$VERSION" "$REV" "$CATEGORY" "$ARCH"                       "$INSTDATE" "$SIZE" "$VENDOR" 
EOF
clean
exit 0
